import argparse

import axipy
import uvicorn
from fastapi import FastAPI, Request, Depends

from repo.File.Repository import factoryRepository,Repository
from repo.utils import loadMws
from webModules.wms.clsWms import WmsAxi
def initAxioma():
    app = axipy.init_axioma()
    return app
def fastServer():
    ''' Получаем параметры из командной строки '''
    parser = argparse.ArgumentParser(description='Server WMS Axioma')
    parser.add_argument('-ht', '--host', help='Name host server', default='localhost', required=False)
    parser.add_argument('-p', '--port', help='Port host server', type=int,default=8000, required=False)
    parser.add_argument('-gh', '--glhost', help='Global Name host server', required=False)
    parser.add_argument('-gp', '--glport', help='Global Port host server', type=int, required=False)
    parser.add_argument('-w', '--wms', help='Path on xml descriptor wms', required=True)
    args = parser.parse_args()

    path_ini=args.wms
    host=args.host
    port=args.port
    global_host=None
    try:
        global_host=args.glhost
    except:
        pass
    if global_host is None:
        global_host=host
    global_port = None
    try:
        global_port = args.glport
    except:
        pass
    if global_port is None:
        global_port=port

    cls_repository,isPreloadMws=factoryRepository(path_ini,global_host,str(global_port))

    wms=WmsAxi(cls_repository,None)
    app = FastAPI()
    app.web_axi={'repository':cls_repository,'wms':wms,'axioma':initAxioma()}
    if isPreloadMws:
        ''' Загружаем все карты из WMS'''
        list_resourceMap = cls_repository.getMapResource()
        loadMws(cls_repository,list_resourceMap)



    @app.get('/WMS')
    async def getWms(request: Request):
        return request.app.web_axi['wms'].getResponse(request.query_params)
        #return {"Hello": "Wms"}

    uvicorn.run(app, host="0.0.0.0", port=port)
if __name__ == "__main__":
    #uvicorn.run(fastServer, host="0.0.0.0", port=8000)
    fastServer()