import os.path
import xml.etree.ElementTree as ET
def BooleanFromString(value:str):
    if value.lower()=='true':
        return True
    return False
def getResourceMap(node_source):
    if isinstance(node_source,list):
        return None
    list_resource=[]
    nodes=node_source.findall('{http://www.opengis.net/wms}Layer')
    for node in nodes:
        node_name = node.find('{http://www.opengis.net/wms}Name')
        if node_name.text is None:
            temp_resources=getResourceMap(node)
            if temp_resources is not None and len(temp_resources):
                list_resource.extend(temp_resources)
                continue
        list_resource.append(node_name.text)
    return list_resource
def getResourceMapTree(tree):
    all_resource=[]
    nodes_base=tree.findall('./{http://www.opengis.net/wms}Capability/{http://www.opengis.net/wms}Layer')
    for node in nodes_base:
        all_resource.extend(getResourceMap(node))

    return all_resource
def loadXmlToString(path_xml):
    tree = ET.parse(path_xml)
    root = tree.getroot()
    return str(ET.tostring(root, encoding='utf-8'), 'UTF-8')
def getTextNode(base_node_tree,node_name,parentNode=None)->str:
    if parentNode is None:
        obj_node= base_node_tree.find(node_name)
        if obj_node is None:
            return None
        return obj_node.text
    obj_node = base_node_tree.find(parentNode)
    return getTextNode(obj_node,node_name)
class Repository:
    __delimiter_folder=':'
    def __init__(self,path_repository,path_wms_Capabilities,path_wmst_Capabilities):
        self.__path_repo=path_repository
        self.__path_wms=path_wms_Capabilities
        self.__path_wmts = path_wmst_Capabilities
        self.__initCapabilities()
    def __initCapabilities(self):
        path_wms_Capabilities=os.path.join(self.__path_repo,self.__path_wms)
        self.__tree_wms = ET.parse(path_wms_Capabilities)
        self.__root_wms = self.__tree_wms.getroot()
        self.__xml_wms_Capabilities=str(ET.tostring(self.__root_wms, encoding='utf-8'), 'UTF-8').replace('ns0:','')
        path_wmts_Capabilities = os.path.join(self.__path_repo, self.__path_wmts)
        self.__tree_wmts = ET.parse(path_wmts_Capabilities)
        self.__root_wmts = self.__tree_wmts.getroot()
        self.__xml_wmts_Capabilities = str(ET.tostring(self.__root_wmts, encoding='utf-8'), 'UTF-8')
    def __updateWms(self,urlwms,host,port):
        url="http://"+host+":"+port+"/"+urlwms
        nodesOnlineResource=self.__tree_wms.findall('/{http://www.opengis.net/wms}Capability/*/*/*/*/*/{http://www.opengis.net/wms}OnlineResource')
        for node in nodesOnlineResource:
            #node.attrib['{http://www.w3.org/1999/xlink}href']=url+"/?"
            #node.set('{http://www.w3.org/1999/xlink}href', url+"/?")
            node.set('{http://www.w3.org/1999/xlink}href', url )
        return
    def updateXml(self,urlwms,host,port):
        self.__updateWms(urlwms,host,port)

        #self.__root_wms = self.__tree_wms.getroot()
        self.__xml_wms_Capabilities = str(ET.tostring(self.__root_wms, encoding='utf-8'), 'UTF-8').replace('ns0:','')

    @property
    def WMSCapabilities(self):
        return '<?xml version="1.0" encoding="UTF-8"?>'+self.__xml_wms_Capabilities
    @property
    def WMTSCapabilities(self):
        return '<?xml version="1.0" encoding="UTF-8"?>'+self.__xml_wmts_Capabilities
    def getFullPath(self,related_path):
        list_item_folder=related_path.split(self.__delimiter_folder)
        out_full_path=self.__path_repo
        for item in list_item_folder:
            out_full_path=os.path.join(out_full_path,item)
        return out_full_path
    @property
    def delimiterFolder(self):
        return self.__delimiter_folder
    def getMapResource(self):
        return getResourceMapTree(self.__tree_wms)
def factoryRepository(path_ini_file,host_use,port):
    host='localhost'
    if host_use is not None:
        host=host_use
    tree = ET.parse(path_ini_file)
    root = tree.getroot()
    path_repository=getTextNode(root,'repository')
    if path_repository is None:
        return None
    urlwms=getTextNode(root,'weburl','WMS')
    path_repo_wms=getTextNode(root,'Capabilities','WMS')
    path_repo_wmts = getTextNode(root, 'Capabilities', 'WMTS')
    str_preloadMap=getTextNode(root, 'preloadMap', 'WMS')
    preloadMap=BooleanFromString(str_preloadMap)
    if path_repo_wmts is not None and path_repo_wms is not None:
        repo= Repository(path_repository,path_repo_wms,path_repo_wmts)
        repo.updateXml(urlwms,host,port)
        return repo,preloadMap
    return None,False
