import axipy
from PySide2 import QtCore
from PySide2.QtGui import QImage
from axipy import view_manager, CoordSystem, Rect
from starlette.datastructures import QueryParams
from fastapi import  Response
def getCoordSystem(crs:str)->CoordSystem:
    if crs.lower().find('epsg:')>=0:
        epsg_cod=crs.lower().replace('epsg:','')
        return CoordSystem.from_epsg(int(epsg_cod))
    return None
def getBound(str_bound:str)->Rect:
    parm_bound=str_bound.split(',')
    return Rect(float(parm_bound[0]),float(parm_bound[1]),float(parm_bound[2]),float(parm_bound[3]))
def getValue(name:str,params:dir):
    value=None
    try:
        value=params[name]
    except:
        pass
    if value is not None:
        return value
    try:
        value=params[name.lower()]
    except:
        pass
    if value is not None:
        return value
    return None
def ImageToBytes(image_map:QImage):
    ba = QtCore.QByteArray()
    buff = QtCore.QBuffer(ba)
    buff.open(QtCore.QIODevice.WriteOnly)
    image_map.save(buff,"PNG")
    return ba.data()
class WmsAxi:
    def __init__(self,repository,axioma_app):
        self.__repo=repository
        self.__axioma=axioma_app
    def getResponse(self,params_request:QueryParams):
        count_params=len(params_request)
        if count_params==0:
            ''' Выдаем WMSCapabilities'''
            return Response(content=self.__repo.WMSCapabilities,media_type="application/xml")
        list_key_lower=list(map(str.lower,list(params_request.keys())))
        '''Capabilities '''
        items_request=list(filter(lambda request: request =='request', list_key_lower))
        if len(items_request)>0:
            value_request=getValue('REQUEST',params_request)
            if value_request.lower()=='getcapabilities':
                ''' Выдаем WMSCapabilities'''
                return Response(content=self.__repo.WMSCapabilities, media_type="application/xml")
            if value_request.lower()=='getmap':
                ''' Формируем растр карты'''
                return self.__getMap(params_request)
        jkl=0
    def __getMap(self,params):
        layers_request=getValue('LAYERS',params)
        ''' Пока исходим из предположения что запрашивается одна карта(слой)'''
        list_item=layers_request.split(self.__repo.delimiterFolder)
        name_mapAxioma=list_item[-1]
        ''' Проверяем карта загружена в Axioma'''
        list_map_view=view_manager.mapviews
        map_view_layer=None
        try:
            map_view_layer=list(filter(lambda map_view:  map_view. title ==name_mapAxioma, list_map_view))[0]
        except:
            pass
        if map_view_layer is None:
            ''' Загрущаем карту'''
            full_path_map=self.__repo.getFullPath(layers_request)
            axipy.gui.Workspace().load_file(full_path_map+".mws")

            try:
                map_view_layer=list(filter(lambda map_view:  map_view. title ==name_mapAxioma, view_manager.mapviews))[0]
            except Exception as ex:
                pass
        if map_view_layer is None:
            return None
        ''' Получаем параметры карты '''
        str_cs=getValue('CRS',params)
        srt_width_image=getValue('WIDTH',params)
        srt_height_image = getValue('HEIGHT', params)
        str_bound_map=getValue('BBOX', params)
        out_cs=getCoordSystem(str_cs)
        out_bound=getBound(str_bound_map)
        image_map=map_view_layer.map.to_image(int(srt_width_image),int(srt_height_image),out_cs,out_bound)
        image_bytes=ImageToBytes(image_map)
        return Response(content=image_bytes, media_type="image/png")


